<?php

session_start();

define ('BASE_DIR', dirname(dirname(__FILE__)));
include(dirname(__FILE__) . '/common.php');


$parseArray = array('message' => '');


// Now check that the script is installed2
$checkQuestionsTableQuery = "show tables like '" . faq_data::tableName('questions') ."'";
$checkCategoriesTableQuery = "show tables like '" . faq_data::tableName('categories') ."'";

$return = faq_data::row($checkQuestionsTableQuery);

$showInstallForm = false;

if(!(is_array($return) && count($return) > 0)) {
	// questions table doesn't exist, show the install form!
	$showInstallForm = true;
}

$return = faq_data::row($checkCategoriesTableQuery);

if(!(is_array($return) && count($return) > 0)) {
	// categories table doesn't exist, show the install form!
	$showInstallForm = true;
}

if($showInstallForm) {
	$_SESSION['install_process'] = true;
	$html = file_get_contents(BASE_DIR . '/faq_admin/display/install_form.phtml');
	$parse = new faq_display_parse($html, $parseArray);
	echo $parse->parse();
	die();
}

if(isset($_SESSION['install_process'])) {
	$_SESSION['install_process'] = false;
	unset($_SESSION['install_process']);
}

if(isset($_SESSION['update_process'])) {
	$_SESSION['update_process'] = false;
	unset($_SESSION['update_process']);
	define('UPDATE_SUCCESS', true);
} else {
	define('UPDATE_SUCCESS', false);
}

if(faq_update::updatesAvailable()) {
	$_SESSION['update_process'] = true;
	$_SESSION['update_album_refresh'] = false;
	$parseArray['oldversion'] = faq_update::versionFormat(faq_settings::get('dbversion'));
	$parseArray['newversion'] = faq_update::versionFormat(FAQ_SCRIPT_VERSION);

	$html = file_get_contents(FAQ_ADMIN_DIR . '/display/update_form.phtml');
	$parse = new faq_display_parse($html, $parseArray);
	echo $parse->parse();
	die();
}
// check if POST action sent for login
if(isset($_POST['submit_login']) && isset($_POST['username']) && isset($_POST['password'])) {
	// user is attempting to log in
	$hashPass = faq_user::hashPass($_POST['password']);

	$user = faq_data::row('SELECT * FROM :users_table WHERE `username` = "' . faq_data::escape($_POST['username']) .'" AND `password` = "'.$hashPass.'"');

	if(!empty($user)) {
		// login successful
		$_SESSION['logged_in'] = true;
		$_SESSION['user_id'] = $user['id'];

		?>
		<script type="text/javascript">
		<!--
			window.location = "index.php?<?php echo rand(5,5000); ?>";
		//-->
		</script>
		<?php
		die();
	} else {
		$parseArray['message'] = 'Sorry, your password and/or username were incorrect.';
	}
}

// if not logged in display login form
if(!isset($_SESSION['logged_in'])
	|| (isset($_SESSION['logged_in']) && $_SESSION['logged_in'] !== true))
{
	$html = file_get_contents(BASE_DIR . '/faq_admin/display/login_form.phtml');
	$parse = new faq_display_parse($html, $parseArray);
	echo $parse->parse();
	die();
}



