var $linksDialog = {};
var $addCategoryDialog = {};
var $userOptionsDialog = {};
var $addQuestionDialog = {};


function showNotification (title, msg, color) {
	if(typeof color === 'undefined') {
		var color = "yellow";
	}

	if(color == "success") {
		color = "green";
	}

	if(color == "failure" || color == "fail" || color == "error")  {
		color = "red";
	}

	$('#notification-inner')
		.removeClass('green')
		.removeClass('red')
		.removeClass('yellow');

	$('#notification-inner').addClass(color);
	$('#notification-inner .message').text(msg);
	$('#notification-inner .title').text(title);
	$('#notification-inner').hide();
	$('#notification-inner').fadeIn();
}

function hideNotification () {
	$('#notification-inner').fadeOut('fast');
}

$(function() {


	$('#categories-list-ul li:last').children('.hierarchy').addClass('h_plus_bottom');

	$('#no_questions_in_category').hide();
	$('#loading_questions').hide();
	$('#questions_for').hide();


	$('#save-category').live('click', function(){
		
		if($('.dialog #category_name').val() == "") {
			alert('Please enter a category name.');
			resetButton('.dialog #save-category');
			return false;
		}

		if($('.dialog #category_id').val() > 0) {
			SaveEditCategory();
		} else {
			SaveNewCategory();
		}
	});

	$('#save-question').live('click', function(){
		if( $('.dialog #q_question').val() == "" || $('.dialog #q_category').val() == "" || $('.dialog #q_answer').val() == "") {
			alert('Please ensure a category is selected and that you have entered both a question and an answer. Fields cannot be left blank.');
			resetButton('.dialog #save-question');
			return false;
		}

		if($('.dialog #q_id').val() > 0) {
			SaveEditQuestion();
		} else {
			SaveNewQuestion();
		}
	});
	
	$('#save-user').live('click', function(){
		$.post('action.php', {'faq_action':'saveuserinfo', 
			'username': $('.dialog #u_username').val(), 
			'password_old': $('.dialog #u_password_old').val(), 
			'password_new': $('.dialog #u_password_new').val(), 
			'password_new_confirm': $('.dialog #u_password_new_confirm').val()
			}, function(json) {
			if(json.success) {
				showNotification("Success", 'The user information has been successfully updated!', "green");
				$userOptionsDialog.dialog('close');
				
			} else {
				var msg = 'Unfortunately the user could not be updated due to an error!';
				if(json.error.length > 0) {
					msg = json.error;
				}
//				showNotification("Error", msg, "red");
				alert(msg);
			}
			resetButton('.dialog #save-user');
		}, 'json');
	});

	$('#notification-close').click(function () {
		hideNotification();
	});
	
	$('#edit-category-wrapper').mouseover(function () {
		if($(this).find('#edit-category').hasClass('edit-category-on')){
			$(this).addClass('hover-dark-bg');
		}
	});

	$('#edit-category-wrapper').mouseout(function () {
		if($(this).find('#edit-category').hasClass('edit-category-on')){
			$(this).removeClass('hover-dark-bg');
		}
	});

	$('.question').live('mouseover', function () {
		$(this).children('.delete-box').addClass('delete-box-bg');
	});

	$('.question').live('mouseout', function () {
		$(this).children('.delete-box').removeClass('delete-box-bg');
	});

	$('.category-name').live('mouseover', function () {
		$(this).find('>.delete-box-cat').addClass('delete-box-bg');
	});

	$('.category-name').live('mouseout', function () {
		$(this).find('>.delete-box-cat').removeClass('delete-box-bg');
	});

	$('.delete-box').live('click', function () {
		var qid = $(this).parent().attr('id').replace('question_row_', '');
		if(confirm("Are you sure you want to delete this question?\n\nClick OK to confirm and delete this question.")) {
			showBigLoader();
			$.post('action.php', {'faq_action': 'deletequestion', 'questionid': qid },
			function(json){

				hideBigLoader();

				if(!json.success) {
					showNotification("Error", 'Unable to delete this question.', 'red');
					return;
				}

				showNotification("Success", 'Question deleted.', 'green');
				$("#question_row_" + json.id).fadeOut('fast').remove();

				if($('.question').size() == 0) {
					$('#no_questions_in_category').show();
				}

			}, 'json');
		}
	});

	$('.delete-box-cat').live('click', function (e) {
		var cid = $(this).parent().parent().attr('id').replace('category_row_', '');
		var cname = $(this).parent().text();
		if(confirm("Are you sure you want to delete the category \""+cname+"\"?\n\nNOTE: ALL SUB-CATEGORIES AND QUESTIONS WILL BE DELETED, TOO.\n\nPlease move those questions and categories if you wish to keep them.\n\nClick OK to confirm and delete this category.")) {
			showBigLoader();
			$.post('action.php', {'faq_action': 'deletecategory', 'categoryid': cid },
				function(json){

					hideBigLoader();

					if(!json.success) {
						showNotification("Error", 'Unable to delete this category.', 'red');
						return;
					}
					
					showNotification("Success", 'Category deleted.', 'green');

					$("#category_row_" + json.id).fadeOut('fast').remove();

					resetTreeImgs();
					resetQuestionsList();
			}, 'json');
		}

		if (!e) var e = window.event;
		e.cancelBubble = true;
		if (e.stopPropagation) e.stopPropagation();
	});

	$('.delete-box, .delete-box-cat').live('mouseover', function () {
		$(this).addClass('delete-box-on');
	});

	$('.delete-box, .delete-box-cat').live('mouseout', function () {
		$(this).removeClass('delete-box-on');
	});

	$('.square-button').live('mouseover', function () {
		$(this).addClass('hover-dark-button-bg');
	});

	$('.square-button').live('mouseout', function () {
		$(this).removeClass('hover-dark-button-bg');
	});

/*	$('li').live('mouseover', function () {
		$(this).addClass('hover-bg');
	});

	$('li').live('mouseout', function () {
		$(this).removeClass('hover-bg');
	});
*/

/** Load Questions from Category **/


	$('.category-name').live('click', function () {
			$('#no_questions_in_category').hide();
			$('#loading_questions').show();
			var catid = $(this).parent().attr('id').replace('category_row_', '');

			$('.current-category-name').text($(this).text());
			$('#questions_for').show();
			$('#questions_only').hide();
			$('#no_cat_selected').hide();
			$('#edit-category').addClass('edit-category-on');
			$("#question-list-ul").html("");
			LoadQuestionList(catid);
	});

/** Launch Category Window **/

	$('#add-category').bind('buttonClicked', function () {
		$addCategoryDialog.dialog('open').dialog( "option", "title", 'Add Category' );
		
		$('.dialog #category_id').val('0');
		$('.dialog #category_name').val('');
		resetButton('#add-category');
		// prevent the default action, e.g., following a link
		return false;
	});

	
/** Launch Question Window **/
	$addCategoryDialog = $('<div class="dialog"></div>')
		.html($('#add_category').html())
		.dialog({
			autoOpen: false,
			title: 'Manage Category',
			modal: true,
			draggable: true,
			resizable: false,
			height: 200,
			width: 440
	});

	$addQuestionDialog = $('<div class="dialog"></div>')
		.html($('#add_question').html())
		.dialog({
			autoOpen: false,
			title: 'Manage Question',
			modal: true,
			draggable: true,
			resizable: false,
			height: 480,
			width: 550
	});

	$userOptionsDialog = $('<div class="dialog"></div>')
		.html($('#user_options').html())
		.dialog({
			autoOpen: false,
			title: 'User Options',
			modal: true,
			draggable: true,
			resizable: false,
			height: 400,
			width: 550
	});

	$linksDialog = $('<div class="dialog"></div>')
		.html($('#view_faq').html())
		.dialog({
			autoOpen: false,
			title: 'Preview FAQ',
			modal: true,
			draggable: true,
			resizable: false,
			height: 400,
			width: 500
	});


	$('#user_options_link').click(function () {
		showBigLoader();
		$.post('action.php', {'faq_action': 'getuserinfo' },
		function(json){
			if(!json.success) {
				var msg = 'Unable to edit this user.';
				if(json.error.length > 0) {
					msg = json.error;
				}
				showNotification("Error", msg, 'red');
				return;
			}
			hideBigLoader();

			$userOptionsDialog.dialog('open');

			// prevent the default action, e.g., following a link
			$('.dialog #u_username').val(json.username);
			$('.dialog #u_uid').val(json.userid);

			$('.dialog #u_password_old').val('');
			$('.dialog #u_password_new').val('');
			$('.dialog #u_password_new_confirm').val('');
			resetButton('#save-user');
		}, 'json');
		
		return false;
	
	});

	$('#view_faq_link').click(function () {
		$linksDialog.dialog('open');
		return false;
	});


	$('#add-question').bind('buttonClicked', function () {
		$addQuestionDialog.dialog('open').dialog( "option", "title", 'Add Question' );

		// prevent the default action, e.g., following a link
		$('.dialog #q_id').val('0');
		$('.dialog #q_question').val('');
		$('.dialog #q_answer').val('');

		$('.dialog #q_category').val($('#current_category').val());
		
		resetButton('#add-question');
		// prevent the default action, e.g., following a link
		return false;
	});

	$('#edit-category').live('click', function () {
		if(!$(this).hasClass('edit-category-on')){
			return;
		}
		showBigLoader();
		$.post('action.php', {'faq_action': 'getcategoryinfo', 'categoryid': $('#current_category').val() },  						
		function(json){
			if(!json.success) {
				var msg = 'Unable to edit this category.';
				if(json.error.length > 0) {
					msg = json.error;
				}
				showNotification("Error", msg, 'red');
				return;
			}
			hideBigLoader();
			$addCategoryDialog.dialog('open').dialog( "option", "title", 'Edit Category' );
			// prevent the default action, e.g., following a link
			$('.dialog #category_name').val(json.category_name);
			$('.dialog #category_id').val(json.category_id);
			$('.dialog #c_category').val(json.parent_id);
		}, 'json');
		
		return false;
	});

			
	$('.edit-question').live('click', function () {
		showBigLoader();
		$.post('action.php', {'faq_action': 'getquestioninfo', 'questionid': $(this).parents('.question').attr('id').replace("question_row_", '') },  						
		function(json){
			if(!json.success) {
				var msg = 'Unable to edit this question.';
				if(json.error.length > 0) {
					msg = json.error;
				}
				showNotification("Error", msg, 'red');
				return;
			}
			hideBigLoader();
			$addQuestionDialog.dialog('open').dialog( "option", "title", 'Edit Question' );
			// prevent the default action, e.g., following a link
			$('.dialog #q_question').val(json.question);
			$('.dialog #q_answer').val(json.answer);
			$('.dialog #q_id').val(json.questionid);
			$('.dialog #q_category').val(json.categoryid);
		}, 'json');
		
		return false;
	});
	
	LoadCategoryList();
});

function SaveNewCategory () {
	$.post('action.php', {'faq_action':'addcategory', 'category_name': $('.dialog #category_name').val(), 'parent': $('.dialog #c_category').val()  }, function(json) {
		if(json.success) {
			showNotification("Success", 'The category ' + $('.dialog #category_name').val() + ' has been successfully added!', "green");
			$addCategoryDialog.dialog('close');
			LoadCategoryList();
			
		} else {
			var msg = 'Unfortunately the new category could not be added due to an error!';
			if(json.error.length > 0) {
				msg = json.error;
			}
//			showNotification("Error", msg, "red");
			aert(msg);
		}

		resetButton('.dialog #save-category');
	}, 'json');
}

function SaveEditCategory () {
	$.post('action.php', {'faq_action':'editcategory', 'category_name': $('.dialog #category_name').val(), 'category_id': $('.dialog #category_id').val(), 'parent': $('.dialog #c_category').val() }, function(json) {
		if(json.success) {
			showNotification("Success", 'The category ' + $('.dialog #category_name').val() + ' has been successfully updated!', "green");
			$addCategoryDialog.dialog('close');
			LoadCategoryList();
			
		} else {
			var msg = 'Unfortunately the category could not be updated due to an error!';
			if(json.error.length > 0) {
				msg = json.error;
			}
			// showNotification("Error", msg, "red");
			alert(msg);
		}
		resetButton('.dialog #save-category');
	}, 'json');
}

function SaveNewQuestion () {
	
	$.post('action.php', {'faq_action':'addquestion', 'question': $('.dialog #q_question').val() , 'category': $('.dialog #q_category').val() , 'answer': $('.dialog #q_answer').val() }, function(json) {
		if(json.success) {

			showNotification("Success",'Your new question has been successfully saved!', "green");
			$addQuestionDialog.dialog('close');
		
			LoadCategoryList();
			LoadQuestionList();
		} else {
			var msg = 'Unfortunately the question could not be added due to an error!';
			if(json.error.length > 0) {
				msg = json.error;
			}
			// showNotification("Error", msg, "red");
			aleter(msg);
		}
		resetButton('.dialog #save-question');
	}, 'json');
}

function SaveEditQuestion () {
	$.post('action.php', {'faq_action':'editquestion', 'questionid': $('.dialog #q_id').val() ,'question': $('.dialog #q_question').val() , 'category': $('.dialog #q_category').val() , 'answer': $('.dialog #q_answer').val() }, function(json) {
		if(json.success) {
			showNotification("Success",'Your new question has been successfully updated!', "green");
			$addQuestionDialog.dialog('close');
			
			
			LoadCategoryList();
			LoadQuestionList();
		} else {
			var msg = 'Unfortunately the question could not be updated due to an error!';
			if(json.error.length > 0) {
				msg = json.error;
			}
			// showNotification("Error", msg, "red");
			alert(msg);
		}
		resetButton('.dialog #save-question');
	}, 'json');
}
	
function LoadQuestionList(catid) {
	if(typeof catid == 'undefined') {
		var catid = $('#current_category').val();
	} else {
		$('#current_category').val(catid);
	}

	$.post('action.php', {'faq_action':'questionlist', 'categoryid': catid }, function(json) {
		$('#question-list-ul').html(json.question_html);
		$('#question-list-ul').sortable({ update: function  (event, ui) {
			showBigLoader();
			var result = $('#' + $(ui.item).parent().attr('id')).sortable('serialize');
			var id = 0;
			id = $('#current_category').val();
			result += '&faq_action=sortquestions&category=' +id;
			$.post('action.php', result, function(json) {
				hideBigLoader();
				if(json.success) {
					showNotification("Success",'The order of questions has been successfully updated!', 'green');
				} else {
					showNotification("Error", 'The order of questions could not be updated due to an error!', 'red');
				}
			}, 'json');
		} });

		$('#loading_questions').hide();
		if(json.question_html == '') {
			$('#no_questions_in_category').show();
		} else {
			$('#no_questions_in_category').hide();
		}
	}, 'json');
	
}


function resetTreeImgs () {

		$('.treeimgs').remove();
		$('ol.sortable ol').each(function () {
			if($(this).attr('id') == 'categories-list-ul') {
				return;
			}
			var child = $(this).find(' > li:last-child').offset();
			if(child == null) {
				return;
			}
			var imgTop = child.top-7;
			var imgLeft = child.left - 14;
			var ol = $(this).offset();
			var height = 0;
			height = child.top - ol.top;

			$('body').append('<div class="treeimgs" style="position: absolute; left: '+(ol.left-14)+'px; top: '+ol.top+'px; background-image: url(\'images/tree/line.png\'); width: 14px; height: '+height+'px;"></div>');
			$('body').append('<img src="images/tree/joinbottom.png" class="treeimgs" style="position: absolute; left: '+imgLeft+'px; top: '+imgTop+'px;" />');

			$(this).find(' > li:not(:last-child)').each(function () { 
				var child = $(this).offset();
				var imgTop = child.top-7;
				var imgLeft = child.left - 14;
				$('body').append('<img src="images/tree/join.png"  class="treeimgs" style="position: absolute; left: '+imgLeft+'px; top: '+imgTop+'px;" />');
			});
		});
}

function LoadCategoryList() {
	$.post('action.php', {'faq_action':'categorylist' }, function(json) {
		if(json.category_html != "") {
			$('#no_cats').hide();
			$('#categories-list-ul').html(json.category_html);
			$('.q_category').html(json.category_list);
			$('.c_category').html("<option value='0'>No Parent Category</option>\n <optgroup label='Categories'>" + json.category_list + "</optgroup>");

			$('ol.sortable').nestedSortable({
				disableNesting: 'no-nest',
				forcePlaceholderSize: true,
				handle: 'div > .handle',
				helper:	'clone',
					noJumpFix: 0,
				items: 'li',
				maxLevels: 0,
				opacity: .6,
				placeholder: 'placeholder',
				revert: 250,
				tabSize: 25,
				tolerance: 'pointer',
				toleranceElement: '> div',
				update: function (event, ui) {
					resetTreeImgs();
					$.post('action.php', 'faq_action=catsort&' + $('ol.sortable').nestedSortable('serialize', {startDepthCount: 0}) , function(json) {
						if(json.success) {
							showNotification("Success",'The order of categories has been successfully updated!', 'green');
						} else {
							showNotification("Error", 'The order of categories could not be updated due to an error!', 'red');
						}
					}, 'json');

				}
			});
			resetTreeImgs();
		} else {
			$('#no_cats').show();
		}
	}, 'json');
	
}
$(window).load(function () {
	resetTreeImgs();
});


var pgLoader = false;
function showBigLoader() {
	if (!pgLoader) {
		$("#pg_loader").fadeIn("fast");
		pgLoader = true;
	}
};
function hideBigLoader() {
	if (pgLoader) {
		var loader = $("#pg_loader");
		loader.stop();
		loader.fadeOut("fast");
		pgLoader = false;
	}
};

function resetQuestionsList () {
	$('#no_cat_selected').show();
	$('#questions_only').show();

	$('#no_questions_in_category').hide();
	$('#loading_questions').hide();
	$('#questions_for').hide();
}