<?php

class faq_display {

	private $template;

	public static $questionId = 0;
	public static $categoryId = 0;
	public static $currentURL = '';
	public static $current_category = array();
	public static $current_question = array();
	public static $catresource;
	public static $current_categories = array();
	public static $questionsInOrder = array();
	public static $qresource;
	private static $counter = 0;

	public function __construct ($template='accordion') {
		$this->template = $template;
	}

	public function loadQuestionSelf ($questionId) {

		$question  = faq_data::row('SELECT * FROM :questions_table WHERE questionid = ' . (int) $questionId );

		$html = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/question_self.phtml');
		$parse = new faq_display_parse($html, $question);
		return $parse->parse();
	}

	static public function init() {
		// get current category ID
		$catid = 0;
		if(isset($_GET['faqcid'])) {
			$catid = (int)$_GET['faqcid'];
			$catid = max(0, $catid);
			if($catid > 0) {
				self::$current_category = faq_data::row('SELECT c.name as cat_name, c.categoryid as cat_id, c.hierarchy as hierarchy, p.name as parent_name, p.categoryid as parent_id FROM :categories_table as c LEFT JOIN `faq_categories` as p ON LEFT(c.hierarchy, LENGTH(c.hierarchy)-3) = p.hierarchy WHERE c.categoryid = ' . (int) $catid);
			}
		}

		$qid = 0;
		// get current question ID
		if (isset($_GET['faqqid'])) {
			$qid = (int)$_GET['faqqid'];
			$qid = max(0, $qid);
			if($qid > 0 ) {
				self::$current_question  = faq_data::row('SELECT * FROM :questions_table WHERE questionid = ' . (int) $qid );
			}
		}

		self::$questionId = $qid;
		self::$categoryId = $catid;

		// get URL
		$qString = preg_replace("/faqcid=[0-9]*/ism", "", $_SERVER['QUERY_STRING']);
		$qString = preg_replace("/faqqid=[0-9]*/ism", "", $qString);
		$qString = preg_replace("/&+/", "&", $qString);
		self::$currentURL = $_SERVER['PHP_SELF'] . '?' . $qString;
	}

	static public function getURL($add) {
		$url = str_replace("&&", "&", self::$currentURL . $add);
		$url = str_replace("?&", "?", $url);
		return $url;
	}

	static public function isCategory() {
		if(self::$questionId > 0) {
			return false;
		}

		return true;
	}

	static public function hasSubCats() {
		if(self::$categoryId == 0 && self::$questionId > 0) {
			return false;
		}

		if(self::$categoryId == 0) {
			$children  = faq_data::query('SELECT * FROM :categories_table WHERE LENGTH(`hierarchy`) = 2 ORDER BY `hierarchy` ASC');
		} else {
			$children  = faq_data::query('SELECT * FROM :categories_table WHERE LEFT(`hierarchy`, ' . (strlen(self::$current_category['hierarchy'])+1) . ') = "' . faq_data::escape(self::$current_category['hierarchy']) . '." AND categoryid != ' . (int)self::$current_category['cat_id'] . ' AND LENGTH(`hierarchy`) = '.(strlen(self::$current_category['hierarchy'])+3).' ORDER BY `hierarchy` ASC');
		}

		$child = faq_data::row($children);

		return !empty($child);
	}

	static public function hasQuestions () {
		if(self::$categoryId == 0 && self::$questionId > 0) {
			return false;
		}


		$questions  = faq_data::query('SELECT * FROM :questions_table WHERE categoryid = ' . (int)self::$categoryId . ' ORDER BY `sortorder` ASC LIMIT 1');
		$q = faq_data::row($questions);

		return !empty($q);
	}

	public static function loadCategories() {
		$cats  = faq_data::query('SELECT c.name as cat_name, c.categoryid as cat_id, c.hierarchy as hierarchy, p.name as parent_name, p.categoryid as parent_id FROM :categories_table as c LEFT JOIN `faq_categories` as p ON LEFT(c.hierarchy, LENGTH(c.hierarchy)-3) = p.hierarchy ORDER BY c.hierarchy ASC');
		while($cat = faq_data::row($cats)) {
			self::$current_categories[$cat['cat_id']] = $cat;
		}
	}

	static public function subcats($categoryId=-1, $notFromRoot=false) {
		if($categoryId == -1) {
			$categoryId = self::$categoryId;
			$current_category = self::$current_category;
		} else {
			if($categoryId > 0) {
				$current_category = self::$current_categories[$categoryId];
			}
		}

		if($notFromRoot) {
			$catInfo = faq_data::row('SELECT * FROM :categories_table WHERE categoryid=' . (int)$categoryId);
			if(is_array($catInfo)) {
				$catInfo['link'] = self::getURL('&faqcid=' . $catInfo['categoryid']);
			}
			return $catInfo;
		}

		if(!isset(self::$catresource[$categoryId]) || !is_resource(self::$catresource[$categoryId])) {
			if($categoryId == 0) {
				self::$catresource[$categoryId]  = faq_data::query('SELECT * FROM :categories_table WHERE LENGTH(`hierarchy`) = 2 ORDER BY `hierarchy` ASC');
			} else {
				self::$catresource[$categoryId]  = faq_data::query('SELECT * FROM :categories_table WHERE LEFT(`hierarchy`, ' . (strlen($current_category['hierarchy'])+1) . ') = "' . faq_data::escape($current_category['hierarchy']) . '." AND categoryid != ' . (int)$current_category['cat_id'] . ' AND LENGTH(`hierarchy`) = '.(strlen($current_category['hierarchy'])+3).' ORDER BY `hierarchy` ASC');
			}
		}
		$cat = faq_data::row(self::$catresource[$categoryId]);
		if(is_array($cat)) {
			$cat['link'] = self::getURL('&faqcid=' . $cat['categoryid']);
		}
		return $cat;
	}

	static public function question($key) {
		if(isset(self::$current_question[$key])) {
			return self::$current_question[$key];
		}
		return false;
	}

	static public function questions($categoryId=-1) {
		if($categoryId == -1) {
			$categoryId = self::$categoryId;
		}

		if(!isset(self::$qresource[$categoryId]) || !is_resource(self::$qresource[$categoryId])) {
			self::$qresource[$categoryId]  = faq_data::query('SELECT * FROM :questions_table WHERE categoryid = ' . (int)$categoryId. ' ORDER BY `sortorder` ASC');
		}

		$q = faq_data::row(self::$qresource[$categoryId]);
		if(is_array($q)) {
			$q['link'] = self::getURL('&faqqid=' . $q['questionid']);
		}
		return $q;
	}

	static public function loadCategoryView () {
		//$questionValues = faq_data::questionById($questionId);

		$html = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/main_view.phtml');
		$htmlCategory = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/category_link.phtml');
		$htmlQuestion = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/question_link.phtml');
		$qString = preg_replace("/faqcid=[0-9]*/ism", "", $_SERVER['QUERY_STRING']);
		$qString = preg_replace("/faqqid=[0-9]*/ism", "", $qString);
		$qString = preg_replace("/&+/", "&", $qString);
		$parentId = 0;

		if(isset($_GET['faqcid'])) {
			$parentId = (int)$_GET['faqcid'];
		}

		// get all sub categories for this category
		$current_category = faq_data::row('SELECT c.name as cat_name, c.categoryid as cat_id, c.hierarchy as hierarchy, p.name as parent_name, p.categoryid as parent_id FROM :categories_table as c LEFT JOIN `faq_categories` as p ON LEFT(c.hierarchy, LENGTH(c.hierarchy)-3) = p.hierarchy WHERE c.categoryid = ' . (int) $parentId );

		// update all the children
		if($parentId == 0) {
			$children  = faq_data::query('SELECT * FROM :categories_table WHERE LENGTH(`hierarchy`) = 2 ORDER BY `hierarchy` ASC');
		} else {
			$children  = faq_data::query('SELECT * FROM :categories_table WHERE LEFT(`hierarchy`, ' . (strlen($current_category['hierarchy'])+1) . ') = "' . faq_data::escape($current_category['hierarchy']) . '." AND categoryid != ' . (int)$current_category['cat_id'] . ' AND LENGTH(`hierarchy`) = '.(strlen($current_category['hierarchy'])+3).' ORDER BY `hierarchy` ASC');
		}

		$categoryList = '';
		while($child = faq_data::row($children)) {
			$child['link'] = str_replace("&&", "&", $_SERVER['PHP_SELF'] . '?' . $qString . '&faqcid=' . $child['categoryid']);
			$parse = new faq_display_parse($htmlCategory, $child);
			$categoryList .= $parse->parse();

		}

		$questions  = faq_data::query('SELECT * FROM :questions_table WHERE categoryid = ' . (int) $parentId . ' ORDER BY `sortorder` ASC');

		$questionList = '';
		while($q = faq_data::row($questions)) {

			$q['link'] = str_replace("&&", "&",$_SERVER['PHP_SELF'] . '?' . $qString . '&faqqid=' . $q['questionid']);
			$parse = new faq_display_parse($htmlQuestion, $q);
			$questionList .= $parse->parse();

		}


		$vars = array('categoryList' => $categoryList, 'questionList' => $questionList);
		$parse = new faq_display_parse($html, $vars);
		$finalHtml = $parse->parse();

		return $finalHtml;
	}

	public function loadAllQuestions() {

		// load the categories and then load the questions
		$layoutHtml = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/question_list.phtml');

		// get all the catgorylist placeholders, there may be more than one

		preg_match_all("#\{\%(categoryList[0-9]*)\}#ism", $layoutHtml, $placeholderMatches);

		$variables = array();

		foreach($placeholderMatches[0] as $placeholderKey=>$placeholder) {

			$thisPlaceholder = $placeholderMatches[1][$placeholderKey];
			$templateSuffix = str_replace('categoryList', '', $thisPlaceholder);


			$questionsQuery = faq_data::query("select * from `" . faq_data::tableName('questions') . "` order by `sortorder` ASC");

			$questionList = array();
			while(($row = faq_data::row($questionsQuery))) {
				if(isset($row['categoryid'])) {
					$questionList[$row['categoryid']][] = $row;
				}
			}

			$finalHtml = $categoryHtml = '';
			$selectors = array();
			$categoriesQuery = faq_data::query("select * from `" . faq_data::tableName('categories') . "` order by `hierarchy` ASC");

			while(($row = faq_data::row($categoriesQuery))) {
				$row['question_list'] = '';

				if(!isset($row['questionList'])) {
					$row['questionList'] = '';
				}

				if(isset($questionList[$row['categoryid']])) {
					$html = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/question_single'.$templateSuffix.'.phtml');

					foreach($questionList[$row['categoryid']] as $question) {

						$parseQuestion = new faq_display_parse($html, $question);
						$row['questionList'] .= $parseQuestion->parse();
					}

					$selectors[] = "#category_list_" . $row['categoryid'];
				}
				$html = file_get_contents(BASE_DIR . '/faq_display/' . $this->template . '/category_single'.$templateSuffix.'.phtml');
				$parse = new faq_display_parse($html, $row);
				$categoryHtml .= $parse->parse();
			}

			$variables[$thisPlaceholder] = $categoryHtml;
		}


		$variables['categorySelectors'] = implode($selectors, ' , ');
		$parse = new faq_display_parse($layoutHtml, $variables);
		$finalHtml = $parse->parse();

		return $finalHtml;
	}

	static public function getCounter() {
		self::$counter++;
		return self::$counter;
	}
}

class faq_display_parse {

	private $vars = array();
	private $html = '';
	public function __construct ($html, $vars) {
		$this->vars = $vars;
		$this->html = $html;
	}

	public function parse () {
		$newHtml = $this->html;
		foreach($this->vars as $name=>$value) {
			$newHtml = str_replace("{%". $name ."}", $value, $newHtml);
		}


		$newHtml = str_replace("{%BASE_PATH}", FAQ_INSTALL_LOCATION, $newHtml);

		return $newHtml;
	}
}

