<?php

class faq_hierarchy {

	public function arrayToHierarchy ($array, $prefix = "")
	{
		$hierarchy = array();

		if(empty($array) || !is_array($array)) {
			return $hierarchy;
		}
		
		$counter = 0;
		foreach($array as $id=>$subs) {
			if(!empty($prefix)) {
				$level = $prefix . '.' . $this->numberToString($counter);
			} else {
				$level = $this->numberToString($counter);
			}
			$hierarchy[$id] = $level;
			$hierarchy = $hierarchy + $this->arrayToHierarchy($subs, $level);
			++$counter;
		}

		return $hierarchy;
	}

	public function hierarchyToArray(&$hierarchy, $length = 2) {
		$array = $children = array();

		if(empty($hierarchy) || !is_array($hierarchy)) {
			return $array;
		}
		
		do {
			$value = current($hierarchy);
			$id = key($hierarchy);

			$thisLength = strlen(str_replace(".", "", $value));
		
			if($thisLength == $length) {
				next($hierarchy);

				$nextValue = current($hierarchy);
				$nextLength = strlen(str_replace(".", "", $nextValue));

				if($nextLength > $length) {
					$children = $this->hierarchyToArray($hierarchy, $nextLength);
			
					$nextValue = current($hierarchy);
					$nextLength = strlen(str_replace(".", "", $nextValue));
				} else {
					$children = array();
				}

				$array[$id] = $children;
			}
			
		} while ( $nextLength >= $length ) ;

		return $array;
	}

	public function numberToString($number){
		$str = (string)$number;
		
		if(strlen($str) == 1) {
			return "0" . $str;
		}

		return $str;
	}
}