<?php

class faq_settings {

	private static $settings = false;

	private static function init() {
		$sql = faq_data::query('select * from :settings_table');
		while($row = faq_data::row($sql)) {
			if(!is_array(self::$settings)) {
				self::$settings = array();
			}
			self::$settings[$row['name']] = $row['value'];
		}
	}

	static public function get ($var) {
		self::checkInit();
		if(isset(self::$settings[$var])) {
			return self::$settings[$var];
		}
		return false;
	}

	static public function checkInit() {
		if (self::$settings == false) {
			self::init();
		}
	}

	static public function getSettings() {
		self::checkInit();

		if(!self::$settings) {
			return array();
		}

		return self::$settings;
	}

	static public function update ($table, $update, $field, $value) {

		$count = faq_data::row('select count(id) as row_count FROM `' . faq_data::tableName($table) . '` WHERE `'.$field.'` = "'.faq_data::escape($value).'"');

		if($count['row_count'] > 0) {
			$query =  'UPDATE `' . faq_data::tableName($table) . '` SET ';
			$format = array();
			foreach($update as $key => $val) {
				if(is_int($val)) {
					$format[] = '`' . $key . '` = ' . $val . ' ';
				} else {
					$format[] = '`' . $key . '` = "' . $val . '" ';
				}
			}

			$query .= implode (',', $format);

			$query .= ' WHERE `'.$field.'` = "'.faq_data::escape($value).'"';

			$result = faq_data::query($query);

		} else {
			$update[$field] = $value;
			$result = faq_settings::insert($table, $update);
		}
		return $result;
	}

	static public function insert ($table, $insert) {
		$query =  'INSERT INTO `' . faq_data::tableName($table) . '` (`';
		$keys = array_keys($insert);
		$query .= implode('`,`', $keys);
		$query .= '`) VALUES ("';
		$query .= implode('","', $insert);
		$query .= '")';

		$result = faq_data::query($query);

		return $result;
	}


}