<?php
include_once(dirname(__FILE__) . '/faq_init.php');
?>

<style type='text/css'>
#faqcontainer ul {
	margin: 0 0 0 15px;
	padding: 0;
}

#faqcontainer li {
	margin: 0 0 0 10px;
	padding: 0;
}

#faqcontainer ul li , #faqcontainer ul {
	list-style-image: none;
	list-style-type: none;
}

#faqcontainer li.category-item {
	list-style-type: square;
}

/* --- Headings --- */
#faqcontainer h1 { font-weight:normal; color:#cf263d}

#faqcontainer h2 {font-weight:normal; color:#cf263d}

#faqcontainer h3 { padding: 0; margin: 5px 0 5px 0; }
#faqcontainer h1, h2, h3 {margin-bottom:1em}

#faqcontainer h3, h5 a {padding:3px 10px}

#faqcontainer h3, h4, h5 {}

#faqcontainer .question-highlight .answer { background-color: #e5e5e5;}
#faqcontainer .question-highlight .question {background-color: #c7c7c7; }

#faqcontainer hr {border: 1px solid grey; border-width: 0 0 1px 0;}

#faqcontainer .answer { padding: 20px;}
#faqcontainer .answer p { margin: 0;}
#faqcontainer .question {margin-bottom: 0; margin-top: 20px; background-color: #F7F7F7; padding: 5px; padding-left: 20px;}

#faq-powered-by {
	padding-top: 30px;
	font-size: 10pt;
}

</style>
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.min.js"></script>
<script  type="text/javascript">
$(document).ready( function (){
	$('#faqcontainer').each(function() {
		console.log($(this).css('font-family'));
		if($(this).css('font-family') == 'serif') {
			$(this).css('font-family', 'Arial');
			$(this).css('font-size', '0.9em');
		}
	});

	$('.faq-top-link').click(function() {
		$('.faq-answer').removeClass('question-highlight');
	});

	$('.faq-link').click(function() {
		$('.faq-answer').removeClass('question-highlight');
		var question = $(this).attr('href');
		$(question).addClass('question-highlight');
		return true;
	});
});
</script>


<div id="faqcontainer">
<a name="faq-top"></a>
	<ul>
	<?php
		function faq_singlepage_categories($categoryId=0, $notFromRoot=false) {
		?>
			<?php while($cat = faq_display::subcats($categoryId, $notFromRoot)): ?>
			<li class="category-item">
				<div id="category-name"> <?php echo $cat['name']; ?></div>
				<div class="inner">
					<ul>
						<?php if($notFromRoot) { echo faq_singlepage_categories($categoryId); } else { echo faq_singlepage_categories($cat['categoryid']); }?>
						<?php while($q = faq_display::questions($cat['categoryid'])):
							faq_display::$questionsInOrder[] = $q;
						?>
						<li>
							<a href="#answer-<?php echo $q['questionid']; ?>" class="faq-link"><?php echo $q['question']; ?></a>
						</li>
						<?php endwhile; ?>
					</ul>
				</div>
			</li>
			<?php  if($notFromRoot) { break; } endwhile;
		}
		faq_display::loadCategories();
		$categoryId = 0;
		$flag = false;
		if(isset($_GET['categoryid']) && (int)$_GET['categoryid'] > 0) {
			$categoryId = (int)$_GET['categoryid'];
			$flag = true;
		}
		faq_singlepage_categories($categoryId, $flag);
	?>
	</ul>


<?php foreach(faq_display::$questionsInOrder as $q): ?>
<div id="answer-<?php echo $q['questionid']; ?>" class="faq-answer">
	<a name="answer-<?php echo $q['questionid']; ?>"></a>
	<h4 class="question" ><?php echo $q['question']; ?></h4>
	<div class="answer">
		<p><?php echo nl2br($q['answer']); ?></p>
		<a href="#faq-top" class="faq-top-link">Top</a>
	</div>
</div>
<?php endforeach; ?>

<div id="faq-powered-by">
	Powered by <a href="http://www.jordie.org/faq-manager.php?s">FAQ Manager</a>
</div>

</div>
